VERSION 4.00
Begin VB.Form frmMain 
   Caption         =   "Test DUMPEVTD.DLL"
   ClientHeight    =   4320
   ClientLeft      =   1635
   ClientTop       =   1575
   ClientWidth     =   7485
   Height          =   4725
   Left            =   1575
   LinkTopic       =   "Form1"
   ScaleHeight     =   4320
   ScaleWidth      =   7485
   Top             =   1230
   Width           =   7605
   Begin VB.CommandButton btnPauseTest 
      Caption         =   "Pause Test"
      Height          =   375
      Left            =   1560
      TabIndex        =   7
      Top             =   120
      Width           =   1215
   End
   Begin VB.CheckBox optRemote 
      Caption         =   "Remote machine:"
      Height          =   255
      Left            =   1680
      TabIndex        =   6
      Top             =   600
      Width           =   1695
   End
   Begin VB.CheckBox optLocal 
      Caption         =   "Local machine"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   600
      Value           =   1  'Checked
      Width           =   1455
   End
   Begin VB.Timer LoopTimer 
      Enabled         =   0   'False
      Interval        =   10000
      Left            =   6840
      Top             =   240
   End
   Begin VB.CheckBox optDebug 
      Caption         =   "Debug enabled"
      Height          =   255
      Left            =   5880
      TabIndex        =   4
      Top             =   120
      Width           =   1455
   End
   Begin VB.TextBox txtComputer 
      Height          =   285
      Left            =   3480
      TabIndex        =   3
      Top             =   600
      Width           =   2775
   End
   Begin VB.ComboBox lstLogFiles 
      Height          =   315
      Left            =   4080
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   120
      Width           =   1575
   End
   Begin VB.ListBox lstResults 
      Height          =   2985
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   7215
   End
   Begin VB.CommandButton btnStartTest 
      Caption         =   "Start Test"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label txtStatus 
      BackColor       =   &H80000000&
      Caption         =   "Paused"
      ForeColor       =   &H00FF0000&
      Height          =   375
      Left            =   3120
      TabIndex        =   8
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit


Private Sub btnPauseTest_Click()
    LoopTimer.Enabled = False
    txtStatus = "Paused"
End Sub

Private Sub btnStartTest_Click()
    LoopTimer.Enabled = True
    txtStatus = "Running"
    DoEvents
End Sub

Private Sub Form_Load()
    lstLogFiles.AddItem "Application"
    lstLogFiles.AddItem "System"
    lstLogFiles.AddItem "Security"
    lstLogFiles.ListIndex = 0
End Sub

Private Sub Form_Resize()
    Dim i, margin
    margin = lstResults.Left
    i = Me.ScaleWidth - margin * 2
    If i > 0 Then lstResults.Width = i
    i = Me.ScaleHeight - lstResults.Top - margin
    If i > 0 Then lstResults.Height = i
    i = Me.ScaleWidth - txtComputer.Left - margin
    If i > 0 Then txtComputer.Width = i
End Sub



Private Sub LoopTimer_Timer()
    Dim ComputerName
    
    If optLocal.Value = 1 Then
        DumpLog ""
    End If
    If optRemote.Value = 1 Then
        DumpLog Trim(txtComputer)
    End If
End Sub

    
Private Sub DumpLog(ComputerName As String)
    Dim rc As Long, hEvt As Long, Oldest As Long, Newest As Long, Cur As Long
    Dim szErr, LogFile, args As EventRecType
    
    MousePointer = vbHourglass
    
    lstResults.AddItem "-------------------------------------------------------------"
    
    LogFile = lstLogFiles.List(lstLogFiles.ListIndex)
    
    lstResults.AddItem "Computer=" & ComputerName & " LogFile=" & LogFile
    rc = DevtOpen(ComputerName, LogFile, hEvt)
    If rc <> 0 Then
        rc = DevtGetError(hEvt, szErr)
        lstResults.AddItem "DevtOpen: error=" & szErr
        GoTo err_exit
    End If
    
    rc = DevtGetOldest(hEvt, Oldest)
    If rc <> 0 Then
        rc = DevtGetError(hEvt, szErr)
        lstResults.AddItem "DevtGetOldest: error=" & szErr
    Else
        lstResults.AddItem "DevtGetOldest: Oldest=" & Str(Oldest)
    End If
    
    rc = DevtGetNewest(hEvt, Newest)
    If rc <> 0 Then
        rc = DevtGetError(hEvt, szErr)
        lstResults.AddItem "DevtGetNewest: error=" & szErr
    Else
        lstResults.AddItem "DevtGetNewest: Newest=" & Str(Newest)
    End If
    
    For Cur = Oldest To Newest
        If Cur Mod 20 = 0 Then DoEvents
        If LoopTimer.Enabled = False Then Exit For
        rc = DevtGetRec(hEvt, Cur, args)
        If rc <> 0 Then
            rc = DevtGetError(hEvt, szErr)
            lstResults.AddItem "rec=" & Str(Cur) & " error=" & szErr
        ElseIf (Cur Mod 40 = 0) And (optDebug.Value = 1) Then
            lstResults.AddItem "rec=" & Str(Cur)
            lstResults.AddItem "   DateTime=" & Format(args.DateTime)
            lstResults.AddItem "   EventID=" & Format(args.EventID)
            lstResults.AddItem "   Type=" & args.Type
            lstResults.AddItem "   Category=" & args.Category
            lstResults.AddItem "   Source=" & args.Source
            lstResults.AddItem "   Computer=" & args.Computer
            lstResults.AddItem "   User=" & args.User
            lstResults.AddItem "   Message=" & args.Message
        End If
    Next
    
    rc = DevtClose(hEvt)
    If rc <> 0 Then
        rc = DevtGetError(hEvt, szErr)
        lstResults.AddItem "DevtClose: error=" & szErr
    End If
    
err_exit:
    lstResults.AddItem "All done"
    MousePointer = vbDefault
End Sub


